import mInt;

// Test the performance improvement in caching the mInt's fieldID

class Addtest
{
  static public void main(String argv[])
  {
    int i;
    mInt x = new mInt(0);
    mInt y = new mInt(1);
    int loops = 500000;
    long empty_loop, start, add, testadd;

    // First, time an empty loop to measure loop overhead

    start = System.currentTimeMillis();

    for(i = 0; i < loops; i++)
    { }

    empty_loop = System.currentTimeMillis() - start;

    System.out.println("Empty loop time: " + empty_loop + " ms");

    // Now do the normal, cached add

    start = System.currentTimeMillis();

    for(i = 0; i < loops; i++)
      x.Add(y);

    add = System.currentTimeMillis() - start - empty_loop;

    System.out.println("Cached add time: " + add + " ms, " +
      loops / (add / 1000) + " iterations/second");

    // Time for the non-cached add

    start = System.currentTimeMillis();

    for(i = 0; i < loops; i++)
      x.testAdd(y);

    testadd = System.currentTimeMillis() - start;

    System.out.println("Non-cached add time: " + testadd + " ms, " +
      loops / (testadd / 1000) + " iterations/second");
  }
}
